<?php
/*
Plugin Name: NEX-Forms ADD ON - Form Themes
Plugin URI: http://codecanyon.net/item/nexforms-the-ultimate-wordpress-form-builder/7103891?ref=Basix
Description: Enables single click overall color scheme change to your form to adapt to your theme instantly. Includes 25 preset Bootstrap Themes and 19 preset Google Materail Design Themes. <strong>Requires at least: <a href="https://codecanyon.net/item/nexforms-the-ultimate-wordpress-form-builder/7103891?ref=Basix" target="_blank" style="display:block">NEX-Forms v7.x</a></strong>
Author: Basix
Version: 7.2
Author URI: http://codecanyon.net/user/Basix/portfolio?ref=Basix
License: GPL
*/

function enqueue_nf_form_themes_scripts($hook) {
wp_enqueue_script('jquery');
wp_enqueue_script('nex-forms-themes-add-on', plugins_url( '/js/themes.js',__FILE__));
}
add_action( 'admin_enqueue_scripts', 'enqueue_nf_form_themes_scripts' );


function nf_not_found_notice_ft() {
    
		if(!function_exists('NEXForms_ui_output'))
			{
			?>
			<div class="error notice">
				<p><?php _e( '<strong>NEX-Forms not installed!</strong> You just installed <strong>Form Themes Add-on for NEX-Forms</strong>. You need the NEX-Forms core plugin to run this add-on! Please get and install <a href="https://codecanyon.net/item/nexforms-the-ultimate-wordpress-form-builder/20947643?ref=Basix">NEX-Forms - The Ultimate WordPress Form Builder</a> to enable the features of this add-on.', 'my_plugin_textdomain' ); ?></p>
			</div>
			<?php
			}
		
}
add_action( 'admin_notices', 'nf_not_found_notice_ft' );